# Udemy

## Prerequisites
Download and extracted [TPD-Keys](https://cdm-project.com/Decryption-Tools/TPD-Keys "TPD-Keys")

Working CDM

[EME Logger Script](https://greasyfork.org/en/scripts/373903-eme-logger "EME Logger Script") (installed on [Tampermonkey](https://www.tampermonkey.net/ "Tampermonkey") add-on) will give you init data. That's your PSSH. This can be found on Developer Tools (ctrl + shift + c) > Console, in the filter bar search for `MediaKeySession::generateRequest` you will find Init Data.

## Instructions

### Obtaining Udemy decryption keys.

1) Login to your Udemy account. (purchases and subscription content both supported)

2) Go to the title you want to decrypt.

3) Start playing the content you want to decrypt.

4) Open web devoloper tools (ctrl+shift+c) and click on the console tab.

5) Refresh the page and play the content again.

6) In the filter bar search for `MediaKeySession::generateRequest` and you should see a field called `Init Data` appear, in that field is your pssh

6a) Convert the and extract the PSSH using the method described [here](https://cdm-project.com/How-To/Obtaining-PSSH "here") under `optional, may be required`, save it somewhere save

7) find the `License URL` in Hulu this can be found using devoloper tools (ctrl+shift+c) and clicking on the network tab, then searching for `method:POST widevine` in the filter bar.

7a) Right click on the most recent (top most) result, go down to `Copy Value` and then slect `Copy as cURL (POSIX)`.
*This was done on firefox*.

7b) Go to [curlconverter.com](https://curlconverter.com/ "curlconverter.com") and paste in what you copied.

7c) Copy to clipboard the output (of headers only), then open `DRMHeaders.py` in your `TPD-keys` directory and paste the newly formatted headers, save and exit.

7d) Navigate to your `TPD-keys` directory via command prompt / terminal.

8) Run with `python tpd-keys.py`.

8b) select option 3 for `Generic with headers from DRMHeaders.py`

9) Insert the `pssh`.

10) Right click the oldest (should me the only, but if not, top most) license URL again and this time select `Copy URL` and paste this into your command prompt waiting for `License URL`.

11) Insert the `License URL`

12) Select proxy if wanted.

13) You should have an output of all the available keys for content.